VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CInternetShortcut"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'*********************************************************************************************
'
' InternetShorcut
'
' Reading Internet Shortcut with its interfaces.
'
'*********************************************************************************************
'
' Author: Eduardo Morcillo
' E-Mail: edanmo@geocities.com
' Web Page: http://www.domaildlx.com/e_morcillo
'
' Created: 05/07/1999
' Last Updated: 07/22/1999
'
'*********************************************************************************************

' InternetShortcut object
Dim m_URL As InternetShortcut

' IPropertyStorage interfaces
Dim m_IPS As IPropertyStorage
Dim m_SiteInfo As CSiteInfo

Dim m_FileName As String
Dim m_Flags As Long
    
Enum urlWindowStyles
    swHide = 0
    swNormal
    swMinimized
    swNormalNoFocus
    swMinimizedNoFocus
End Enum

'*********************************************************************************************
' Set flags used to change the URL
'*********************************************************************************************
Public Property Let Flags(ByVal New_Flags As IURL_SETURL_FLAGS)

    m_Flags = New_Flags
    
End Property

'*********************************************************************************************
' Get flags used to change the URL
'*********************************************************************************************
Public Property Get Flags() As IURL_SETURL_FLAGS

    Flags = m_Flags
    
End Property

'*********************************************************************************************
' Returns the file where the icon is in.
'*********************************************************************************************
Public Property Get IconFile() As String
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_ICONFILE
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    ' Check if the result is valid
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        
        ' String values are in LPWSTR variants.
        ' VB does not understand this kind of
        ' variants so we must to convert it.
        
        IconFile = ConvertToString(Value)
        
    End If
    
End Property

'*********************************************************************************************
' Sets the icon file
'*********************************************************************************************
Public Property Let IconFile(ByVal New_IconFile As String)
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_ICONFILE
    
    Value = New_IconFile
    
    ' The properties must be a LPWSTR, since
    ' VB does not support LPWSTRs and BSTRs
    ' are LPWSTR we must change only the
    ' variant type
    
    ConvertToLPWSTR Value
    
    ' Write the property
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Returns the icon index
'*********************************************************************************************
Public Property Get IconIndex() As Long
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_ICONINDEX
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    ' Check if there's a IconIndex
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        IconIndex = Value
    End If
    
End Property

'*********************************************************************************************
' Sets the icon index
'*********************************************************************************************
Public Property Let IconIndex(ByVal New_IconIndex As Long)
Dim PROP As PROPSPEC, Value As Variant

    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_ICONINDEX
    
    Value = New_IconIndex
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
End Property

'*********************************************************************************************
' Returns the hotkey
'*********************************************************************************************
Public Property Get Hotkey() As Integer
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_HOTKEY
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    ' Check if there's a IconIndex
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Hotkey = Value
    End If
    
End Property

'*********************************************************************************************
' Sets the hotkey
'*********************************************************************************************
Public Property Let Hotkey(ByVal New_Hotkey As Integer)
Dim PROP As PROPSPEC, Value As Variant

    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_HOTKEY
    
    Value = New_Hotkey
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
End Property

'*********************************************************************************************
' Returns the page author
'*********************************************************************************************
Public Property Get Author() As String
Dim PROP As PROPSPEC, Value As Variant
    
    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_AUTHOR
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Author = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets the author
'*********************************************************************************************
Public Property Let Author(ByVal New_Author As String)
Dim PROP As PROPSPEC, Value As Variant

    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_AUTHOR
    
    Value = New_Author
    
    ConvertToLPWSTR Value
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

Public Property Get SiteInfo() As CSiteInfo

    Set SiteInfo = m_SiteInfo
    
End Property

'*********************************************************************************************
' Returns the WorkingFolder
'*********************************************************************************************
Public Property Get WorkingFolder() As String
Dim PROP As PROPSPEC, Value As Variant
    
    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_WORKINGDIR
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        WorkingFolder = Value
    End If
    
End Property

'*********************************************************************************************
' Sets the WorkingFolder
'*********************************************************************************************
Public Property Let WorkingFolder(ByVal New_WorkingFolder As String)
Dim PROP As PROPSPEC, Value As Variant
    
    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_WORKINGDIR
    
    Value = New_WorkingFolder
    
    ConvertToLPWSTR Value
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Returns the description
'*********************************************************************************************
Public Property Get Description() As String
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_DESCRIPTION
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Description = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets the description
'*********************************************************************************************
Public Property Let Description(ByVal New_Description As String)
Dim PROP As PROPSPEC, Value As Variant
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_DESCRIPTION
    
    Value = New_Description
    
    ConvertToLPWSTR Value
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Returns Whats New
'*********************************************************************************************
Public Property Get WhatsNew() As String
Dim PROP As PROPSPEC, Value As Variant
    
    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_WHATSNEW
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        WhatsNew = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets Whats New
'*********************************************************************************************
Public Property Let WhatsNew(ByVal New_WhatsNew As String)
Dim PROP As PROPSPEC, Value As Variant

    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_WHATSNEW
    
    Value = New_WhatsNew
    
    ConvertToLPWSTR Value
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Returns Show command
'*********************************************************************************************
Public Property Get WindowStyle() As urlWindowStyles
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_SHOWCMD
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    WindowStyle = Value
    
End Property

'*********************************************************************************************
' Sets Show command
'*********************************************************************************************
Public Property Let WindowStyle(ByVal New_WindowStyle As urlWindowStyles)
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_SHOWCMD
    
    Value = New_WindowStyle
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
End Property

'*********************************************************************************************
' Returns the name
'*********************************************************************************************
Public Property Get Name() As String
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_NAME
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Name = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets the name
'*********************************************************************************************
Public Property Let Name(ByVal New_Name As String)
Dim PROP As PROPSPEC, Value As Variant

    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_NAME
    
    Value = New_Name
    
    ConvertToLPWSTR Value
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Returns the comments
'*********************************************************************************************
Public Property Get Comment() As String
Dim PROP As PROPSPEC, Value As Variant
    
    ' Get IconFile from m_IPS
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_COMMENT
    
    m_IPS.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Comment = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets the comments
'*********************************************************************************************
Public Property Let Comment(ByVal New_Comment As String)
Dim PROP As PROPSPEC, Value As Variant

    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_IS_COMMENT
    
    Value = New_Comment
    
    ConvertToLPWSTR Value
    
    m_IPS.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Execute a command
'*********************************************************************************************
Public Sub InvokeCommand(ByVal CommandStr As String, Optional ByVal Parent As Long, Optional ByVal InvokeFlags As IURL.IURL_INVOKECOMMAND_FLAGS = IURL_INVOKECOMMAND_FL_USE_DEFAULT_VERB)
Dim INVCMD As URLINVOKECOMMANDINFO

    With INVCMD
        .dwcbSize = Len(INVCMD)
        .dwFlags = InvokeFlags
        .hwndParent = Parent
        .pcszVerb = StrPtr(CommandStr)
    End With
    
    m_URL.InvokeCommand INVCMD

End Sub

'*********************************************************************************************
' Load a shortcut file
'*********************************************************************************************
Public Sub Load(ByVal URLFile As String)
Dim IP As IPersistFile
    
    ' Get the IPersistFile interface
    Set IP = m_URL
    
    ' Load the file
    IP.Load URLFile, FILE_ALL_ACCESS
    
    ' Each time we load a shortcut
    ' we must get the new storages
    Set m_IPS = OpenIPS_Shortcut(m_URL)
    m_SiteInfo.Update m_URL
    
    ' Store the current filename
    m_FileName = URLFile
    
End Sub


'*********************************************************************************************
' Save a shortcut file
'*********************************************************************************************
'
' Changes: 7/14/99 - Optional Filename and SaveCopy parameters added

Public Sub Save(Optional ByVal NewFileName As String, Optional SaveCopy As Boolean = False)
Dim IP As IPersistFile

    ' Save properties
    m_IPS.Commit 1
    m_SiteInfo.Save
    
    Set IP = m_URL
    
    ' If there's a new filename save the
    ' shortcut with it
    If NewFileName <> "" Then
        
        IP.Save NewFileName, 0
        
        ' If SaveCopy if False we will
        ' replace the m_FileName property
        If Not SaveCopy Then m_FileName = NewFileName
        
    Else
        IP.Save m_FileName, 0
    End If
    
End Sub

'*********************************************************************************************
' Returns the target URL
'*********************************************************************************************
Public Property Get URL() As String
Dim Ptr As Long

    Ptr = m_URL.GetURL
     
    URL = Ptr2StrW(Ptr)
    
End Property

'*********************************************************************************************
' Sets the target URL
'*********************************************************************************************
Public Property Let URL(ByVal New_URL As String)
Dim FMTID As IID

    New_URL = StrConv(New_URL & vbNullChar, vbUnicode)
    m_URL.SetURL New_URL, m_Flags
    
    ' Update storages
    Set m_IPS = OpenIPS_Shortcut(m_URL)
    m_SiteInfo.Update m_URL
    
End Property

Private Sub Class_Initialize()

    ' Create a new InternetShortcut object
    Set m_URL = New InternetShortcut
        
    ' Open storages
    Set m_IPS = OpenIPS_Shortcut(m_URL)
    
    ' Create a CSiteInfo object
    Set m_SiteInfo = New CSiteInfo
        
    ' Set the default flags
    m_Flags = IURL_SETURL_FL_GUESS_PROTOCOL
    
End Sub

Private Sub Class_Terminate()
 
    ' Save changes
    Save
    
    Set m_IPS = Nothing
    Set m_SiteInfo = Nothing
    Set m_URL = Nothing
    
End Sub


