VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSiteInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'*********************************************************************************************
'
' InternetShorcut
'
' Shortcut site info
'
'*********************************************************************************************
'
' Author: Eduardo Morcillo
' E-Mail: edanmo@geocities.com
' Web Page: http://www.domaildlx.com/e_morcillo
'
' Created: 05/22/1999
' Last Updated: 07/22/1999
'
'*********************************************************************************************

Dim m_IPSSite As IPropertyStorage

'*********************************************************************************************
' Returns the page author
'*********************************************************************************************
Public Property Get Author() As String
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_AUTHOR
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Author = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets the author
'*********************************************************************************************
Public Property Let Author(ByVal New_Author As String)
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_AUTHOR
    
    Value = New_Author
    
    ConvertToLPWSTR Value
    
    m_IPSSite.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

Friend Sub Save()

    m_IPSSite.Commit 1
    
End Sub

Friend Sub Update(ByVal InetShortcut As InternetShortcut)
Dim FMTID As IID, IPSS As IPropertySetStorage
    
    On Error Resume Next
    
    ' Save the current state before updating
    m_IPSSite.Commit 1
    
    Set IPSS = InetShortcut
    
    With FMTID
        .Data1 = &H214A1
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With
    
    Set m_IPSSite = IPSS.Open(FMTID, 2)
    
End Sub

'*********************************************************************************************
' Returns the visit count
'*********************************************************************************************
Public Property Get VisitCount() As Long
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_VISITCOUNT
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        VisitCount = Value
    End If
    
End Property

'*********************************************************************************************
' Sets the Visit Count
'*********************************************************************************************
Public Property Let VisitCount(ByVal New_Count As Long)
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_VISITCOUNT
    
    m_IPSSite.WriteMultiple 1, PROP, Value, 2
    
End Property

'*********************************************************************************************
' Returns the page description
'*********************************************************************************************
Public Property Get Description() As String
Dim PROP As PROPSPEC, Value As Variant
    
    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_DESCRIPTION
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Description = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets the description
'*********************************************************************************************
Public Property Let Description(ByVal New_Description As String)
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_DESCRIPTION
    
    Value = New_Description
    
    ConvertToLPWSTR Value
    
    m_IPSSite.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Returns Whats New
'*********************************************************************************************
Public Property Get WhatsNew() As String
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_WHATSNEW
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        WhatsNew = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets Whats New
'*********************************************************************************************
Public Property Let WhatsNew(ByVal New_WhatsNew As String)
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_WHATSNEW
    
    Value = New_WhatsNew
    
    ConvertToLPWSTR Value
    
    m_IPSSite.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property


'*********************************************************************************************
' Returns the page name
'*********************************************************************************************
Public Property Get Title() As String
Dim PROP As PROPSPEC, Value As Variant
    
    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_TITLE
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Title = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Returns the comments
'*********************************************************************************************
Public Property Get Comment() As String
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_COMMENT
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Comment = ConvertToString(Value)
    End If
    
End Property

'*********************************************************************************************
' Sets the comments
'*********************************************************************************************
Public Property Let Comment(ByVal New_Comment As String)
Dim PROP As PROPSPEC, Value As Variant
    
    If m_IPSSite Is Nothing Then Exit Property

    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_COMMENT
    
    Value = New_Comment
    
    ConvertToLPWSTR Value
    
    m_IPSSite.WriteMultiple 1, PROP, Value, 2
    
    ConvertToBSTR Value
    
End Property

'*********************************************************************************************
' Returns the last visited date
'*********************************************************************************************
Public Property Get LastVisited() As Date
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_LASTVISIT
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        LastVisited = FILETIMEToDate(Value)
    End If
    
End Property

'*********************************************************************************************
' Returns the subscription cookie
'*********************************************************************************************
Public Property Get Subscription() As Currency
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_SUBSCRIPTION
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        Subscription = UI82CY(Value)
    End If
    
End Property


'*********************************************************************************************
' Returns the site code page
'*********************************************************************************************
Public Property Get CodePage() As Long
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_CODEPAGE
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        CodePage = Value
    End If
    
End Property

'*********************************************************************************************
' Returns the last modified date
'*********************************************************************************************
Public Property Get LastModified() As Date
Dim PROP As PROPSPEC, Value As Variant

    If m_IPSSite Is Nothing Then Exit Property
    
    PROP.ulKind = PRSPEC_PROPID
    PROP.ID_or_LPWSTR = PID_INTSITE_LASTMOD
    
    m_IPSSite.ReadMultiple 1, PROP, Value
    
    If Not IsEmpty(Value) And IsValidVariant(Value) Then
        LastModified = FILETIMEToDate(Value)
    End If
    
End Property


Private Sub Class_Terminate()
    
    ' Save changes
    m_IPSSite.Commit 1
    
    Set m_IPSSite = Nothing
    
End Sub


