Attribute VB_Name = "mdlInternetShortcut"
Option Explicit

'*********************************************************************************************
'
' InternetShortcut
'
' Const, declarations and support functions module
'
'*********************************************************************************************
'
' Author: Eduardo Morcillo
' E-Mail: edanmo@geocities.com
' Web Page: http://www.domaildlx.com/e_morcillo
'
' Created: 07/22/1999
' Last Updated: 07/22/1999
'
'*********************************************************************************************

' String functions
Public Declare Function lstrlenW Lib "kernel32" (ByVal PtrStr As Long) As Long
Public Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal L As Long)

Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Declare Function VariantTimeToSystemTime Lib "oleaut32.dll" (ByVal vtime As Double, lpSystemTime As SYSTEMTIME) As Long
Declare Function SystemTimeToVariantTime Lib "oleaut32.dll" (lpSystemTime As SYSTEMTIME, vtime As Double) As Long
Declare Function FileTimeToSystemTime Lib "kernel32" (lpCurrency As Currency, lpSystemTime As SYSTEMTIME) As Long
Declare Function SystemTimeToFileTime Lib "kernel32" (lpSystemTime As SYSTEMTIME, lpCurrency As Currency) As Long
Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpCurrency As Currency, lpLocalCurrency As Currency) As Long
Declare Function LocalFileTimeToFileTime Lib "kernel32" (lpCurrency As Currency, lpLocalCurrency As Currency) As Long

Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal Ptr As Long)
'*********************************************************************************************
' Converts a FILETIME variant to Date
'*********************************************************************************************
Public Function FILETIMEToDate(Var As Variant) As Date
Dim FT As Currency, VT As Double, ST As SYSTEMTIME

    ' Get FILETIME from variant
    MoveMemory FT, ByVal VarPtr(Var) + 8, Len(FT)
    
    ' Convert UTC FILETIME to Local FILETIME
    FileTimeToLocalFileTime FT, FT
    
    ' Convert FILETIME to SYSTEMTIME
    FileTimeToSystemTime FT, ST
    
    ' Convert SYSTEMTIME to Date & Time serial
    SystemTimeToVariantTime ST, VT

    FILETIMEToDate = VT
    
End Function

'*********************************************************************************************
' Converts a Date to a FILETIME variant
'*********************************************************************************************
Public Function DateToFILETIME(ByVal D As Date) As Variant
Dim FT As Currency, VT As Double, ST As SYSTEMTIME

    ' Convert Date to serial
    VT = D
    
    ' Convert serial to SYSTEMTIME
    VariantTimeToSystemTime VT, ST
    
    ' Convert SYSTEMTIME to FILETIME
    SystemTimeToFileTime ST, FT
    
    ' Convert local FILETIME to UTC FILETIME
    LocalFileTimeToFileTime FT, FT
    
    ' Set the variant
    MoveMemory ByVal VarPtr(DateToFILETIME), VT_FILETIME, 2
    MoveMemory ByVal VarPtr(DateToFILETIME) + 8, FT, Len(FT)
    
End Function


'*********************************************************************************************
' Check if the variant is valid. IPropertyStorage returns
' a VT_ILLEGAL variant if a property is not defined.
' VB does not understand VT_ILLEGAL and crashes on any
' access to the variant value.
'*********************************************************************************************
Public Function IsValidVariant(Var As Variant)
Dim VarVB As VariantVB

    MoveMemory VarVB, Var, Len(VarVB)
    
    IsValidVariant = VarVB.VariantType <> -1 ' VT_ILLEGAL = -1
    
End Function


'*********************************************************************************************
' "Converts" a BSTR variant to LPWSTR variant
'*********************************************************************************************
Public Sub ConvertToLPWSTR(Var As Variant)
Dim VariantType As Integer
    
    ' BSTRs are already LPWSTRs so we only have
    ' to change the variant type
    
    VariantType = VT_LPWSTR
    
    ' Copy variant type
    MoveMemory Var, VariantType, 2
    
End Sub


'*********************************************************************************************
' Converts a LPWSTR variant to String
'*********************************************************************************************
Public Function ConvertToString(Var As Variant) As String
Dim VarS As VariantVB
    
    ' Copy the variant to a struct that can be
    ' used in VB
    MoveMemory VarS, Var, Len(VarS)
    
    ' Check if the variant is a LPWSTR
    If VarS.VariantType = VT_LPWSTR Then
    
        ' Convert the pointer to a string
        ConvertToString = Ptr2StrW(VarS.lValue1)
        
    End If
    
End Function


'*********************************************************************************************
' "Converts" a variant to BSTR variant
'*********************************************************************************************
Public Sub ConvertToBSTR(Var As Variant)
Dim VariantType As Integer
       
    VariantType = vbString ' vbString = VT_BSTR
    
    ' Copy variant type
    MoveMemory Var, VariantType, 2
    
End Sub



'*********************************************************************************************
' Opens the IPropertyStorage of a shortcut
'*********************************************************************************************
Public Function OpenIPS_Shortcut(ByVal InetShtct As InternetShortcut) As IPropertyStorage
Dim FMTID As IID, IPSS As IPropertySetStorage
    
    Set IPSS = InetShtct
    
    With FMTID
        .Data1 = &H214A0
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With
    
    Set OpenIPS_Shortcut = IPSS.Open(FMTID, 2)

End Function

'*********************************************************************************************
' Returns a String from a LPWSTR pointer
'*********************************************************************************************
Public Function Ptr2StrW(ByVal Ptr As Long, Optional Free As Boolean = True) As String

   Ptr2StrW = String$(lstrlenW(Ptr), 0)
   MoveMemory ByVal StrPtr(Ptr2StrW), ByVal Ptr, Len(Ptr2StrW) * 2
   
   If Free Then CoTaskMemFree Ptr

End Function



'*********************************************************************************************
' "Converts" a UI8 variant to currency
'*********************************************************************************************
Public Function UI82CY(Var As Variant) As Currency

    MoveMemory Var, vbCurrency, 2
    
    UI82CY = Var * 10000
    
End Function


